<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>/home/tylerwbrown/Code/Personal/Challenges/Haskell/divisible_sum_pairs.hs</title>
</head>
<head>
<link type='text/css' rel='stylesheet' href='liquid.css' />
</head>

<body>
<hr>
Put mouse over identifiers to see inferred types
<pre><span class=hs-linenum> 1: </span><a class=annot href="#"><span class=annottext>GHC.Types.Module</span><span class='hs-comment'>{-# LANGUAGE FlexibleInstances, UndecidableInstances, DuplicateRecordFields #-}</span></a>
<span class=hs-linenum> 2: </span>
<span class=hs-linenum> 3: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>Data.List</span>
<span class=hs-linenum> 4: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>System.Environment</span>
<span class=hs-linenum> 5: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>System.IO</span>
<span class=hs-linenum> 6: </span>
<span class=hs-linenum> 7: </span><a class=annot href="#"><span class=annottext>a -&gt; (a -&gt; b) -&gt; b</span><span class='hs-layout'>(</span></a><span class='hs-varop'>|&gt;</span><span class='hs-layout'>)</span> <a class=annot href="#"><span class=annottext>a</span><span class='hs-varid'>x</span></a> <a class=annot href="#"><span class=annottext>a -&gt; b</span><span class='hs-varid'>f</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : a -&gt; b | v == f}</span><span class='hs-varid'>f</span></a> <span class='hs-varid'>x</span> 
<span class=hs-linenum> 8: </span>
<span class=hs-linenum> 9: </span><a class=annot href="#"><span class=annottext>[GHC.Integer.Type.Integer]</span><span class='hs-definition'>ar</span></a> <span class='hs-keyglyph'>=</span> <span class='hs-keyglyph'>[</span><span class='hs-num'>1</span><span class='hs-layout'>,</span> <span class='hs-num'>3</span><span class='hs-layout'>,</span> <span class='hs-num'>2</span><span class='hs-layout'>,</span> <span class='hs-num'>6</span><span class='hs-layout'>,</span> <span class='hs-num'>1</span><span class='hs-layout'>,</span> <span class='hs-num'>2</span><span class='hs-keyglyph'>]</span>
<span class=hs-linenum>10: </span>
<span class=hs-linenum>11: </span><a class=annot href="#"><span class=annottext>[a] -&gt; [(a, a)]</span><span class='hs-definition'>pairs</span></a> <span class='hs-conid'>[]</span> <span class='hs-keyglyph'>=</span> <span class='hs-conid'>[]</span>
<span class=hs-linenum>12: </span><span class='hs-definition'>pairs</span> <span class='hs-layout'>(</span><span class='hs-varid'>x</span><span class='hs-conop'>:</span><span class='hs-varid'>xs</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : [(a, a)] | len v &lt;= len xs
                &amp;&amp; len v &gt;= len xs
                &amp;&amp; len v &gt;= 0
                &amp;&amp; len v == len xs}</span><span class='hs-keyglyph'>[</span></a><span class='hs-layout'>(</span><span class='hs-varid'>x</span><span class='hs-layout'>,</span> <span class='hs-varid'>y</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>|</span> <span class='hs-varid'>y</span> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>xs</span><span class='hs-keyglyph'>]</span> <span class='hs-varop'>++</span> <a class=annot href="#"><span class=annottext>[a] -&gt; [(a, a)]</span><span class='hs-varid'>pairs</span></a> <span class='hs-varid'>xs</span>
<span class=hs-linenum>13: </span>
<span class=hs-linenum>14: </span><a class=annot href="#"><span class=annottext>(GHC.Real.Integral a) =&gt; a -&gt; [a] -&gt; GHC.Types.Int</span><span class='hs-definition'>divisibleSumPairs</span></a> <a class=annot href="#"><span class=annottext>a</span><span class='hs-varid'>k</span></a> <a class=annot href="#"><span class=annottext>[a]</span><span class='hs-varid'>ar</span></a> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>length</span> <span class='hs-varop'>$</span> <a class=annot href="#"><span class=annottext>[(a, a)]</span><span class='hs-varid'>pairs</span></a> <span class='hs-varid'>ar</span> <span class='hs-varop'>|&gt;</span> 
<span class=hs-linenum>15: </span>  <a class=annot href="#"><span class=annottext>x1:[(a, a)] -&gt; {v : [(a, a)] | len v &lt;= len x1}</span><span class='hs-varid'>filter</span></a> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>(a, a)</span><span class='hs-keyglyph'>\</span></a><span class='hs-layout'>(</span><span class='hs-varid'>x</span><span class='hs-layout'>,</span> <span class='hs-varid'>y</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>-&gt;</span> <a class=annot href="#"><span class=annottext>a</span><span class='hs-layout'>(</span></a><span class=hs-error><a class=annot href="#"><span class=annottext>a</span><span class='hs-layout'>(</span></a></span><span class=hs-error><a class=annot href="#"><span class=annottext>{VV : a | VV == x + y}</span><span class='hs-varid'>x</span></a></span><span class=hs-error> </span><span class=hs-error><a class=annot href="#"><span class=annottext>x1:a -&gt; x2:a -&gt; {VV : a | VV == x1 + x2}</span><span class='hs-varop'>+</span></a></span><span class=hs-error> </span><span class=hs-error><span class='hs-varid'>y</span></span><span class=hs-error><span class='hs-layout'>)</span></span><span class=hs-error> </span><span class=hs-error><a class=annot href="#"><span class=annottext>x1:a -&gt; x2:{VV : a | VV /= 0} -&gt; {VV : a | VV == x1 mod x2
                                           &amp;&amp; (0 &lt;= x1
                                               &amp;&amp; 0 &lt; x2 =&gt; 0 &lt;= VV
                                                            &amp;&amp; VV &lt; x2)}</span><span class='hs-varop'>`mod`</span></a></span><span class=hs-error> </span><span class=hs-error><span class='hs-varid'>k</span></span><span class='hs-layout'>)</span> <a class=annot href="#"><span class=annottext>x1:a -&gt; x2:a -&gt; {v : GHC.Types.Bool | v &lt;=&gt; x1 == x2}</span><span class='hs-varop'>==</span></a> <span class='hs-num'>0</span><span class='hs-layout'>)</span>
<span class=hs-linenum>16: </span>
<span class=hs-linenum>17: </span><a class=annot href="#"><span class=annottext>(GHC.Num.Num a, GHC.Classes.Eq a) =&gt;
a -&gt; (GHC.Types.IO [[GHC.Types.Char]])</span><span class='hs-definition'>readMultipleLinesAsStringArray</span></a> <span class='hs-num'>0</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>[[GHC.Types.Char]] -&gt; (GHC.Types.IO [[GHC.Types.Char]])</span><span class='hs-varid'>return</span></a> <span class='hs-conid'>[]</span>
<span class=hs-linenum>18: </span><span class='hs-definition'>readMultipleLinesAsStringArray</span> <span class='hs-varid'>n</span> <span class='hs-keyglyph'>=</span> <span class='hs-keyword'>do</span>
<span class=hs-linenum>19: </span>    <a class=annot href="#"><span class=annottext>[GHC.Types.Char]</span><span class='hs-varid'>line</span></a> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>getLine</span>
<span class=hs-linenum>20: </span>    <a class=annot href="#"><span class=annottext>[[GHC.Types.Char]]</span><span class='hs-varid'>rest</span></a> <span class='hs-keyglyph'>&lt;-</span> <a class=annot href="#"><span class=annottext>(GHC.Num.Num a, GHC.Classes.Eq a) =&gt;
a -&gt; (GHC.Types.IO [[GHC.Types.Char]])</span><span class='hs-varid'>readMultipleLinesAsStringArray</span></a><span class='hs-layout'>(</span><span class=hs-error><a class=annot href="#"><span class=annottext>a</span><span class='hs-varid'>n</span></a></span><span class=hs-error> </span><span class=hs-error><a class=annot href="#"><span class=annottext>x1:a -&gt; x2:a -&gt; {VV : a | VV == x1 - x2}</span><span class='hs-comment'>-</span></a></span><span class=hs-error> </span><span class=hs-error><span class='hs-num'>1</span></span><span class='hs-layout'>)</span>
<span class=hs-linenum>21: </span>    <a class=annot href="#"><span class=annottext>[[GHC.Types.Char]] -&gt; (GHC.Types.IO [[GHC.Types.Char]])</span><span class='hs-varid'>return</span></a> <span class='hs-layout'>(</span><span class='hs-varid'>line</span> <span class='hs-conop'>:</span> <span class='hs-varid'>rest</span><span class='hs-layout'>)</span>
<span class=hs-linenum>22: </span>
<span class=hs-linenum>23: </span><a class=annot href="#"><span class=annottext>(GHC.Types.IO ())</span><span class='hs-definition'>main</span></a> <span class='hs-keyglyph'>=</span> <span class='hs-keyword'>do</span>
<span class=hs-linenum>24: </span>    <a class=annot href="#"><span class=annottext>[GHC.Types.Char]</span><span class='hs-varid'>stdout</span></a> <span class='hs-keyglyph'>&lt;-</span> <a class=annot href="#"><span class=annottext>{v : [GHC.Types.Char] -&gt; (GHC.Types.IO [GHC.Types.Char]) | v == System.Environment.getEnv}</span><span class='hs-varid'>getEnv</span></a> <span class='hs-str'>"OUTPUT_PATH"</span>
<span class=hs-linenum>25: </span>    <a class=annot href="#"><span class=annottext>GHC.IO.Handle.Types.Handle</span><span class='hs-varid'>fptr</span></a> <span class='hs-keyglyph'>&lt;-</span> <a class=annot href="#"><span class=annottext>{v : [GHC.Types.Char] -&gt; GHC.IO.IOMode.IOMode -&gt; (GHC.Types.IO GHC.IO.Handle.Types.Handle) | v == GHC.IO.Handle.FD.openFile}</span><span class='hs-varid'>openFile</span></a> <span class='hs-varid'>stdout</span> <span class='hs-conid'>WriteMode</span>
<span class=hs-linenum>26: </span>
<span class=hs-linenum>27: </span>    <a class=annot href="#"><span class=annottext>[GHC.Types.Char]</span><span class='hs-varid'>nkTemp</span></a> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>getLine</span>
<span class=hs-linenum>28: </span>    <span class='hs-keyword'>let</span> <a class=annot href="#"><span class=annottext>[[GHC.Types.Char]]</span><span class='hs-varid'>nk</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : [GHC.Types.Char] -&gt; [[GHC.Types.Char]] | v == Data.OldList.words}</span><span class='hs-varid'>words</span></a> <span class='hs-varid'>nkTemp</span>
<span class=hs-linenum>29: </span>
<span class=hs-linenum>30: </span>    <span class='hs-keyword'>let</span> <span class='hs-sel'>_n</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>read</span> <span class='hs-layout'>(</span><span class='hs-varid'>head</span> <span class='hs-varid'>nk</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>Int</span>
<span class=hs-linenum>31: </span>    <span class='hs-keyword'>let</span> <a class=annot href="#"><span class=annottext>GHC.Types.Int</span><span class='hs-varid'>k</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>[GHC.Types.Char] -&gt; GHC.Types.Int</span><span class='hs-varid'>read</span></a> <span class='hs-layout'>(</span><span class=hs-error><a class=annot href="#"><span class=annottext>[GHC.Types.Char]</span><span class='hs-varid'>nk</span></a></span><span class=hs-error> </span><span class=hs-error><span class='hs-varop'>!!</span></span><span class=hs-error> </span><span class=hs-error><span class='hs-num'>1</span></span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>Int</span>
<span class=hs-linenum>32: </span>
<span class=hs-linenum>33: </span>    <a class=annot href="#"><span class=annottext>[GHC.Types.Char]</span><span class='hs-varid'>arTemp</span></a> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>getLine</span>
<span class=hs-linenum>34: </span>    <span class='hs-keyword'>let</span> <a class=annot href="#"><span class=annottext>[GHC.Types.Int]</span><span class='hs-varid'>ar</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>x1:[[GHC.Types.Char]] -&gt; {v : [GHC.Types.Int] | len v == len x1}</span><span class='hs-conid'>Data.List.map</span></a> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>[GHC.Types.Char] -&gt; GHC.Types.Int</span><span class='hs-varid'>read</span></a> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>String</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-conid'>Int</span><span class='hs-layout'>)</span> <span class='hs-varop'>.</span> <span class='hs-varid'>words</span> <span class='hs-varop'>$</span> <span class='hs-varid'>arTemp</span>
<span class=hs-linenum>35: </span>
<span class=hs-linenum>36: </span>    <span class='hs-keyword'>let</span> <a class=annot href="#"><span class=annottext>GHC.Types.Int</span><span class='hs-varid'>result</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>GHC.Types.Int -&gt; [GHC.Types.Int] -&gt; GHC.Types.Int</span><span class='hs-varid'>divisibleSumPairs</span></a> <span class='hs-varid'>k</span> <span class='hs-varid'>ar</span>
<span class=hs-linenum>37: </span>    <a class=annot href="#"><span class=annottext>{v : GHC.IO.Handle.Types.Handle -&gt; [GHC.Types.Char] -&gt; (GHC.Types.IO ()) | v == GHC.IO.Handle.Text.hPutStrLn}</span><span class='hs-varid'>hPutStrLn</span></a> <span class='hs-varid'>fptr</span> <span class='hs-varop'>$</span> <a class=annot href="#"><span class=annottext>GHC.Types.Int -&gt; [GHC.Types.Char]</span><span class='hs-varid'>show</span></a> <span class='hs-varid'>result</span>
<span class=hs-linenum>38: </span>
<span class=hs-linenum>39: </span>    <a class=annot href="#"><span class=annottext>{v : GHC.IO.Handle.Types.Handle -&gt; (GHC.Types.IO ()) | v == GHC.IO.Handle.hFlush}</span><span class='hs-varid'>hFlush</span></a> <span class='hs-varid'>fptr</span>
<span class=hs-linenum>40: </span>    <a class=annot href="#"><span class=annottext>{v : GHC.IO.Handle.Types.Handle -&gt; (GHC.Types.IO ()) | v == GHC.IO.Handle.hClose}</span><span class='hs-varid'>hClose</span></a> <span class='hs-varid'>fptr</span>
</pre>
</body>
</html>